Bug 1113967 (CVE-2014-4667)

Summary: CVE-2014-4667 kernel: sctp: sk_ack_backlog wrap-around problem
Product: [Other] Security Response Reporter: Petr Matousek <pmatouse>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: agordeev, anton, aquini, bhu, davej, dhoward, esammons, fhrbata, gansalmon, iboverma, itamar, jforbes, jkacur, jonathan, jross, jrusnack, jwboyer, kernel-maint, kernel-mgr, lgoncalv, lwang, madhu.chinakonda, matt, mchehab, mcressma, npajkovs, pholasek, plougher, rt-maint, rvrbovsk, vkrizan, williams
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20140612,reported=20140605,source=customer,cvss2=5/AV:N/AC:L/Au:N/C:N/I:N/A:P,rhel-5/kernel=notaffected,rhel-6/kernel=affected,rhel-7/kernel=affected,mrg-2/realtime-kernel=affected,fedora-all/kernel=affected,cwe=CWE-190
Fixed In Version: Doc Type: Bug Fix
Doc Text:
An integer underflow flaw was found in the way the Linux kernel's Stream Control Transmission Protocol (SCTP) implementation processed certain COOKIE_ECHO packets. By sending a specially crafted SCTP packet, a remote attacker could use this flaw to prevent legitimate connections to a particular SCTP server socket to be made.
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-09-19 09:33:10 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1085932, 1112726, 1113969, 1113971, 1113972, 1113973    
Bug Blocks: 1110682    

Description Petr Matousek 2014-06-27 11:10:37 UTC
Description of the problem:
For a TCP-style socket, while processing the COOKIE_ECHO chunk in
sctp_sf_do_5_1D_ce(), after it has passed a series of sanity check, a
new association would be created in sctp_unpack_cookie(), but afterwards,
some processing maybe failed, and sctp_association_free() will be called
to free the previously allocated association, in sctp_association_free(),
sk_ack_backlog value is decremented for this socket, since the initial
value for sk_ack_backlog is 0, after the decrement, it will be 65535, a
wrap-around problem happens, and if we want to establish new associations
afterward in the same socket, ABORT would be triggered since sctp deem the
accept queue as full. 

A remote attacker can block further connection to the particular sctp
server socket by sending a specially crafted sctp packet.

Upstream patch:
https://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/commit/?id=d3217b15a19a4779c39b212358a5c71d725822ee

Acknowledgements:

Red Hat would like to thank Gopal Reddy Kodudula of Nokia Siemens Networks for reporting this issue.

Comment 3 Petr Matousek 2014-06-27 11:14:42 UTC
Created kernel tracking bugs for this issue:

Affects: fedora-all [bug 1113973]

Comment 4 Fedora Update System 2014-06-30 10:28:45 UTC
kernel-3.14.9-200.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 5 Petr Matousek 2014-07-22 16:15:27 UTC
Statement:

This issue does not affect the Linux kernel packages as shipped with Red Hat Enterprise Linux 5.

Comment 6 errata-xmlrpc 2014-07-22 18:04:57 UTC
This issue has been addressed in following products:

  MRG for RHEL-6 v.2

Via RHSA-2014:0913 https://rhn.redhat.com/errata/RHSA-2014-0913.html

Comment 7 Fedora Update System 2014-07-25 10:08:27 UTC
kernel-3.14.13-100.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 8 Martin Prpič 2014-08-05 12:09:18 UTC
IssueDescription:

An integer underflow flaw was found in the way the Linux kernel's Stream Control Transmission Protocol (SCTP) implementation processed certain COOKIE_ECHO packets. By sending a specially crafted SCTP packet, a remote attacker could use this flaw to prevent legitimate connections to a particular SCTP server socket to be made.

Comment 9 errata-xmlrpc 2014-08-06 17:11:57 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 7

Via RHSA-2014:1023 https://rhn.redhat.com/errata/RHSA-2014-1023.html

Comment 10 errata-xmlrpc 2014-09-09 17:57:35 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2014:1167 https://rhn.redhat.com/errata/RHSA-2014-1167.html